var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import PropTypes from "prop-types";
import cx from "classnames";

var config = {
  defaultStarCount: 5,
  gold: "#ffb400",
  charcoal: "#333"
};

var RatingComponent = (_temp = _class = function (_Component) {
  _inherits(RatingComponent, _Component);

  function RatingComponent(props) {
    _classCallCheck(this, RatingComponent);

    var _this = _possibleConstructorReturn(this, _Component.call(this));

    var value = props.value;

    _this.state = {
      value: value
    };
    return _this;
  }

  RatingComponent.getDerivedStateFromProps = function getDerivedStateFromProps(props, state) {
    var value = props.value;

    if (value != null && value !== state.value) {
      return { value: value };
    }
    return null;
  };

  RatingComponent.prototype.onChange = function onChange(inputValue) {
    var _props = this.props,
        editing = _props.editing,
        value = _props.value;

    if (!editing) return;
    if (value != null) return;

    this.setState({ value: inputValue });
  };

  RatingComponent.prototype.onStarClick = function onStarClick(index, value, name, e) {
    e.stopPropagation();
    var _props2 = this.props,
        onStarClick = _props2.onStarClick,
        editing = _props2.editing;

    if (!editing) return;

    onStarClick && onStarClick(index, value, name, e);
  };

  RatingComponent.prototype.onStarHover = function onStarHover(index, value, name, e) {
    e.stopPropagation();
    var _props3 = this.props,
        onStarHover = _props3.onStarHover,
        editing = _props3.editing;

    if (!editing) return;

    onStarHover && onStarHover(index, value, name, e);
  };

  RatingComponent.prototype.onStarHoverOut = function onStarHoverOut(index, value, name, e) {
    e.stopPropagation();
    var _props4 = this.props,
        onStarHoverOut = _props4.onStarHoverOut,
        editing = _props4.editing;

    if (!editing) return;

    onStarHoverOut && onStarHoverOut(index, value, name, e);
  };

  RatingComponent.prototype.renderStars = function renderStars() {
    var _this2 = this;

    var _props5 = this.props,
        name = _props5.name,
        starCount = _props5.starCount;
    var value = this.state.value;

    var stars = [];

    var radioStyles = {
      display: "none",
      position: "absolute",
      marginLeft: -9999
    };

    var starStyles = function starStyles(i, value) {
      var _props6 = _this2.props,
          starColor = _props6.starColor,
          emptyStarColor = _props6.emptyStarColor,
          editing = _props6.editing;

      return {
        float: "right",
        cursor: editing ? "pointer" : "default",
        color: value >= i ? starColor : emptyStarColor
      };
    };

    var labelClass = function labelClass(i) {
      return "dv-star-rating-star " + (value >= i ? "dv-star-rating-full-star" : "dv-star-rating-empty-star");
    };

    var _loop = function _loop(i) {
      var id = name + "_" + i;
      var starInput = React.createElement("input", {
        key: "input_" + id,
        id: id,
        style: radioStyles,
        className: "dv-star-rating-input",
        type: "radio",
        name: name,
        value: i,
        checked: value === i,
        onChange: _this2.onChange.bind(_this2, i, name)
      });
      var starLabel = React.createElement(
        "label",
        {
          key: "label_" + id,
          htmlFor: id,
          style: starStyles(i, value),
          className: labelClass(i),
          onClick: function onClick(e) {
            return _this2.onStarClick(i, value, name, e);
          },
          onMouseOver: function onMouseOver(e) {
            return _this2.onStarHover(i, value, name, e);
          },
          onMouseLeave: function onMouseLeave(e) {
            return _this2.onStarHoverOut(i, value, name, e);
          }
        },
        _this2.renderIcon(i, value, name, id)
      );

      stars.push(starInput);
      stars.push(starLabel);
    };

    for (var i = starCount; i > 0; i--) {
      _loop(i);
    }

    return stars.length ? stars : null;
  };

  RatingComponent.prototype.renderIcon = function renderIcon(index, value, name, id) {
    var _props7 = this.props,
        renderStarIcon = _props7.renderStarIcon,
        renderStarIconHalf = _props7.renderStarIconHalf;

    var isRenderingHalfStar = typeof renderStarIconHalf === "function" && Math.ceil(value) === index && value % 1 !== 0;
    var isRenderingStar = typeof renderStarIcon === "function";

    var renderBlackStar = function renderBlackStar() {
      return React.createElement(
        "i",
        { key: "icon_" + id, style: { fontStyle: "normal" } },
        "\u2605"
      );
    };

    return isRenderingHalfStar ? renderStarIconHalf(index, value, name, id) : isRenderingStar ? renderStarIcon(index, value, name, id) : renderBlackStar();
  };

  RatingComponent.prototype.render = function render() {
    var _props8 = this.props,
        editing = _props8.editing,
        className = _props8.className;

    var styles = {
      display: "inline-block",
      position: "relative"
    };
    var classes = cx("dv-star-rating", {
      "dv-star-rating-non-editable": !editing
    }, className);

    return React.createElement(
      "div",
      { style: styles, className: classes },
      this.renderStars()
    );
  };

  return RatingComponent;
}(Component), _class.defaultProps = {
  starCount: config.defaultStarCount,
  editing: true,
  starColor: config.gold,
  emptyStarColor: config.charcoal
}, _temp);
RatingComponent.propTypes = process.env.NODE_ENV !== "production" ? {
  name: PropTypes.string.isRequired,
  value: PropTypes.number,
  editing: PropTypes.bool,
  starCount: PropTypes.number,
  starColor: PropTypes.string,
  onStarClick: PropTypes.func,
  onStarHover: PropTypes.func,
  onStarHoverOut: PropTypes.func,
  renderStarIcon: PropTypes.func,
  renderStarIconHalf: PropTypes.func
} : {};


export default RatingComponent;